# Execute this file with
# > bash print-perf-data.sh

# Collect simulation step run times from file with all stdouts of PIConGPU
# Perform statistical analysis of results on the fly
#
# 2022, Rene Widera, Klaus Steiniger


DIR="/home/steinigk/WORK/2022_PaperEz/"

#cd ${DIR}/paper_binaries_2022/params/PaperThermal; fileBase="result_" #NVIDIA
#cd ${DIR}/amd_paper_binaries_2022/params/PaperThermal; fileBase="amd_result_" #AMD
cd ${DIR}/cpu_paper_binaries_2022/params/PaperThermal; fileBase="cpu_result_" #CPU: use column $8 in awk since the runtime increases to minutes

printf "%s\n" $(pwd)

pattern=$(grep "#" ${fileBase}0.txt | tr " " ".")

# Calculate and print sample mean as well standard uncertainty of mean (=standard deviation of mean)
for i in $(echo $pattern) ; do echo $i; cat ${fileBase}*.txt | grep -e "calc" -e "#" | grep -A1 "$i" | grep -v -e "#" -e "-" | awk 'BEGIN{newValue=0.; count=0; delta=0.0; mean=0.0; delta2=0.0; M2=0.0}{newValue=$7*10.; ++count; delta=newValue-mean; mean+=delta/count; delta2=newValue-mean; M2+=delta*delta2}END{variance=M2/(count-1); stdDevOfMean=sqrt(variance/count); printf("mean = ( %f $\\pm$ %f) msec/step with a level of confidence of approximately 95%%, sampleVariance = %f (msec/step)**2\n", mean, 2*stdDevOfMean, variance)}' ; done
#for i in $(echo $pattern) ; do echo $i; cat ${fileBase}*.txt | grep -e "calc" -e "#" | grep -A1 "$i" | grep -v -e "#" -e "-" | awk '{ print $7 }'; done
